# ADAM
# Need to get y_for_q6 from Q5
x=x_for_q6
y=y_for_q6
amplitude=np.max(y)
# normalize y_max as 1
nrml=1e3
y/=amplitude
y*=nrml
amplitude=nrml

### 구현하기
"""
def dI_dk(k):
  global x, amplitude
  num=2*amplitude*np.cos(beta*x)**2*np.sin(k*x)*(k*x*np.cos(k*x)-np.sin(k*x))
  denum=k**3*x**2
  return num/denum

def dI_dbeta(beta):
  global x, amplitude
  num=2*amplitude*np.sin(beta*x)*np.cos(beta*x)*np.sin(k*x)**2
  denum=k**2*x
  return num/denum
"""
def intensity(k, beta):
  global amplitude, x
  return amplitude*(np.sin(k*x)/k/x)**2*(np.cos(beta*x))**2

def df_dx(func, vari):
  global amplitude, x
  k=vari[0]; beta=vari[1]
  h=1e-8
  df_dk=(func(k+h, beta)-func(k-h, beta))/(2*h)
  df_dbeta=(func(k, beta+h)-func(k, beta-h))/(2*h)
  return df_dk, df_dbeta

# LSQ=1/N*SUM((y_pred-y_true)**2)
def LSE(k, beta):
  global x, y, intensity
  lse=np.mean((intensity(k, beta)-y)**2)    # use mean
  return lse

def dL_dx(vari):
  global df_dx, intensity, x, y
  k=vari[0]; beta=vari[1]
  df=df_dx(intensity, vari)
  dL_dk=np.mean(2*(intensity(k, beta)-y)*df[0])
  dL_dbeta=np.mean(2*(intensity(k, beta)-y)*df[1])
  return np.array([dL_dk, dL_dbeta])

def adam(df, x, max_iter=1e4, alpha=0.1, beta1=0.9, beta2=0.999, epsilon=1e-7, thrs=1e-6):
  global LSE
  m=np.array([0, 0]); v=np.array([0, 0])  # moment 1, moment 2
  lse=[]
  t=1
  while t<max_iter:
    lse.append(LSE(x[0], x[1]))
    gx=df(x)
    m=beta1*m+(1-beta1)*gx
    v=beta2*v+(1-beta2)*gx**2
    mh=m/(1-beta1**t)
    vh=v/(1-beta2**t)
    x_new=x-alpha*mh/(vh**(1/2)+epsilon)
    if(sum(abs(x-x_new))<thrs): break
    x=x_new
    t+=1
  return x, lse

if __name__=="__main__":
  k=10; beta=10
  vari=[k, beta]
  # beta에 대한 Local Minimum이 많음(alpha를 크게 줘서 step을 크게 학습)
  vari, lse=adam(dL_dx, vari, alpha=3e2, beta1=0.99, beta2=0.9999)
  k=vari[0]; beta=vari[1]

  plt.plot(lse, color="#ff00ff")
  plt.title("Loss")
  plt.yscale("log"); plt.ylabel(f"$Loss[log]$")
  plt.show()
  print("\n", end="", flush=True)

  y_pred=intensity(k, beta)
  ax=plt.subplot(121)
  ax.plot(x, y, color="#00a3d2")
  ax.set_title("y_true")
  plt.xticks([]); plt.yticks([])
  ax=plt.subplot(122)
  ax.plot(x, y_pred, color="#881824")
  ax.set_title("y_pred")
  plt.xticks([]); plt.yticks([])
  plt.show()
  print("\n", end="", flush=True)
  
  plt.plot(x, y, color="#00a3d2", alpha=0.7, label="y_true")
  plt.plot(x, y_pred, color="#881824", alpha=0.7, label="y_pred")
  plt.title("k=%.2f, beta=%.2f" %(k, beta))
  plt.legend()
  plt.show()
